val fetchArrayInfoM :
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  (Variable.array * VFpBasics.vfparraytype) list *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val fetchVfpinstrsM :
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpinstr list *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val storeVfpinstrsM : 'a -> 'b * 'c -> unit * ('b * 'a)
val addVfpinstrM :
  VFpBasics.vfpinstr ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val arrayToTypeM :
  Variable.array ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfparraytype *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val arrayinfoToAccess :
  VFpBasics.vfparraytype * VSimdBasics.realimag -> VFpBasics.vfpaccess
val variableToTupledForm :
  Variable.variable -> VSimdBasics.realimag * Variable.array * int
val conditionallyCopyVarM : 'a -> 'a option -> 'b -> 'a * 'b
val extractUseReturnVfpregM :
  (VFpBasics.vfpreg -> 'a -> 'b * 'c) ->
  VFpBasics.vfpreg option -> 'a -> VFpBasics.vfpreg * 'c
val extractUseVfpregM :
  (VFpBasics.vfpreg -> 'a -> 'b * 'c) ->
  VFpBasics.vfpreg option -> 'a -> unit * 'c
val varexprToVfpreg : Variable.variable -> VFpBasics.vfpreg
val timesexprToNormalized : Expr.expr * Expr.expr -> Expr.expr * Expr.expr
val plusexprToChecked : 'a list -> 'a list
val exprToNegated : Expr.expr -> Expr.expr
val summandCmp : Expr.expr -> Expr.expr -> int
val exprToVfpinstrsM :
  Expr.expr ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpreg *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val exprToVfpinstrsM' :
  Expr.expr ->
  VFpBasics.vfpreg option ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpreg *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val uminusvarexprToVfpinstrM :
  Variable.variable ->
  VFpBasics.vfpreg ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val timesexprToVfpinstrsM :
  Expr.expr * Expr.expr ->
  VFpBasics.vfpreg option ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpreg *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val timesconstexprToVfpinstrsM' :
  Expr.expr ->
  Number.number ->
  VFpBasics.vfpreg ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val timesexprToVfpinstrsM' :
  Expr.expr ->
  Expr.expr ->
  VFpBasics.vfpreg ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val plusexprToVfpinstrsM :
  Expr.expr list ->
  VFpBasics.vfpreg option ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpreg *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val summandToVfpsummandM :
  Expr.expr ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpsummand *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val loadToVfpinstrsM :
  Variable.variable ->
  VFpBasics.vfpreg ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val storeToVfpinstrsM :
  Variable.variable ->
  VFpBasics.vfpreg ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val assignmentToVfpinstrsM :
  Expr.assignment ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  unit *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val assignmentsToVfpinstrsM :
  Expr.assignment list ->
  (Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list ->
  VFpBasics.vfpinstr list *
  ((Variable.array * VFpBasics.vfparraytype) list * VFpBasics.vfpinstr list)
val assignmentsToVfpinstrs :
  (Variable.array * VFpBasics.vfparraytype) list ->
  Expr.assignment list -> VFpBasics.vfpinstr list
