val unitM : 'a -> 'b -> ('a -> 'b -> 'c -> 'd) -> 'c -> 'd
val failM : 'a -> 'b -> (unit -> 'c) -> 'c
val catch1M :
  'a ->
  (unit -> 'b -> (unit -> 'b -> 'c -> 'd) -> 'c -> 'd) ->
  'b -> (unit -> 'b -> 'c -> 'd) -> 'c -> 'd
val fetchStateM : 'a -> ('a -> 'a -> 'b -> 'c) -> 'b -> 'c
val storeStateM : 'a -> 'b -> (unit -> 'a -> 'c -> 'd) -> 'c -> 'd
val ( >>= ) :
  ('a -> ('b -> 'c -> 'd -> 'e) -> 'f -> 'g) ->
  ('b -> 'c -> 'h -> 'd -> 'e) -> 'a -> 'h -> 'f -> 'g
val ( ||| ) :
  (unit -> 'a -> 'b -> ('c -> 'd) -> 'e) ->
  (unit -> 'a -> 'b -> 'f -> 'd) -> 'a -> 'b -> 'f -> 'e
val posAssertM :
  bool -> 'a -> (unit -> 'a -> (unit -> 'b) -> 'b) -> (unit -> 'b) -> 'b
val negAssertM :
  bool -> 'a -> (unit -> 'a -> (unit -> 'b) -> 'b) -> (unit -> 'b) -> 'b
val ifThenElseM :
  (unit -> 'a -> ('b -> 'c -> 'd -> 'e) -> ('f -> 'g) -> 'h) ->
  ('b -> 'c -> 'i -> 'd -> 'e) ->
  (unit -> 'a -> 'i -> (unit -> 'g) -> 'g) -> 'a -> 'i -> (unit -> 'g) -> 'h
val notM :
  ('a -> 'b -> ('c -> 'd -> 'e -> 'f) -> ('g -> 'h) -> 'i) ->
  'a -> 'b -> ('a -> 'b -> (unit -> 'f) -> 'h) -> (unit -> 'f) -> 'i
val onceM :
  ('a -> 'b -> ('c -> 'd -> 'e -> 'f) -> 'g -> 'h) ->
  'a -> 'b -> ('c -> 'd -> 'g -> 'f) -> 'g -> 'h
val findallM :
  ('a -> 'b -> ('c -> 'd -> (unit -> 'e) -> 'e) -> ('f -> 'g) -> 'h) ->
  'a -> 'b -> ('c list -> 'b -> 'i -> 'g) -> 'i -> 'h
val runM :
  ('a ->
   'b -> ('c -> 'd -> 'e -> ('c * 'd) option) -> ('f -> 'g option) -> 'h) ->
  'a -> 'b -> 'h
val runP :
  ('a -> 'b -> ('c -> 'd -> 'e -> bool) -> ('f -> bool) -> 'g) ->
  'a -> 'b -> 'g
