val mapPairM :
  ('a -> 'b -> ('c -> 'b -> 'd -> 'e) -> 'd -> 'e) ->
  'a * 'a -> 'b -> ('c * 'c -> 'b -> 'd -> 'e) -> 'd -> 'e
val mapTripleM :
  ('a -> 'b -> ('c -> 'b -> 'd -> 'e) -> 'd -> 'e) ->
  'a * 'a * 'a -> 'b -> ('c * 'c * 'c -> 'b -> 'd -> 'e) -> 'd -> 'e
val mapM :
  ('a -> 'b -> ('c -> 'b -> 'd -> 'e) -> 'd -> 'e) ->
  'a list -> 'b -> ('c list -> 'b -> 'd -> 'e) -> 'd -> 'e
val consM : 'a -> 'a list -> 'b -> ('a list -> 'b -> 'c -> 'd) -> 'c -> 'd
val memberM' :
  'a -> 'a list -> 'b -> ('a -> 'b -> ('c -> 'd) -> 'd) -> ('c -> 'd) -> 'd
val memberM :
  'a list -> 'b -> ('a -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val selectM' :
  'a ->
  'a list ->
  'b -> ('a * 'a list -> 'b -> ('c -> 'd) -> 'd) -> ('c -> 'd) -> 'd
val selectM :
  'a list ->
  'b -> ('a * 'a list -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val selectFirstM :
  ('a -> bool) ->
  'a list ->
  'b -> ('a * 'a list -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val deleteFirstM :
  ('a -> bool) ->
  'a list ->
  'b -> ('a list -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val permutationM :
  'a list ->
  'b -> ('a list -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val forallM :
  ('a -> 'b -> ('c -> 'b -> 'd -> 'e) -> 'd -> 'e) ->
  'a list -> 'b -> (unit -> 'b -> 'd -> 'e) -> 'd -> 'e
val existsM :
  ('a -> 'b -> 'c -> (unit -> 'd) -> 'd) ->
  'a list -> 'b -> 'c -> (unit -> 'd) -> 'd
val betweenM' :
  int ->
  int -> int -> 'a -> (int -> 'a -> ('b -> 'c) -> 'c) -> ('b -> 'c) -> 'c
val betweenM :
  int -> int -> 'a -> (int -> 'a -> (unit -> 'b) -> 'b) -> (unit -> 'b) -> 'b
val disjM :
  (unit -> 'a -> 'b -> (unit -> 'c) -> 'c) list ->
  'a -> 'b -> (unit -> 'c) -> 'c
val optionToValueM :
  'a option -> 'b -> ('a -> 'b -> (unit -> 'c) -> 'c) -> (unit -> 'c) -> 'c
val iterM :
  ('a -> 'b -> ('c -> 'b -> 'd -> 'e) -> 'd -> 'e) ->
  'a list -> 'b -> (unit -> 'b -> 'd -> 'e) -> 'd -> 'e
val iterirevM :
  (int -> 'a -> 'b -> (unit -> 'b -> 'c -> 'd) -> 'c -> 'd) ->
  int -> 'a list -> 'b -> (unit -> 'b -> 'c -> 'd) -> 'c -> 'd
val suffixM :
  'a list -> 'b -> ('a list -> 'b -> ('c -> 'd) -> 'd) -> ('c -> 'd) -> 'd
